using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
// One of the methods in here returns an IowReport, so we need to use our Library
using org.wayoda.csiow;

namespace CsDemo {
    /// <summary>
    /// A simple panel with 64 HexTextBoxes and a write button.
    /// When the user hits the write-button we call the Mainform
    /// through a delegate registered in the constructor of the 
    /// main form. 
    /// </summary>
    public partial class WritePanel : UserControl {
        public writeReportDelegate wdelegate;

        public WritePanel() {
            InitializeComponent();
        }

        public void setEnabled(bool enabled) {
            this.Enabled=enabled;
            foreach(Control cntrl in Controls) {
                cntrl.Enabled=enabled;
            }
            writeBtn.Enabled=enabled;
        }


        private void writeBtn_Click(object sender, EventArgs e) {
            wdelegate.Invoke(this.getWriteReport());  
        }

        public IowReport getWriteReport() {
            IowReport rep=new IowReport();
            rep[0]=ht_id.getHexValue();
            rep[1]=ht0.getHexValue();
            rep[2]=ht1.getHexValue();
            rep[3]=ht2.getHexValue();
            rep[4]=ht3.getHexValue();
            rep[5]=ht4.getHexValue();
            rep[6]=ht5.getHexValue();
            rep[7]=ht6.getHexValue();
            rep[8]=ht7.getHexValue();
            rep[9]=ht8.getHexValue();
            rep[10]=ht9.getHexValue();
            rep[11]=ht10.getHexValue();
            rep[12]=ht11.getHexValue();
            rep[13]=ht12.getHexValue();
            rep[14]=ht13.getHexValue();
            rep[15]=ht14.getHexValue();
            rep[16]=ht15.getHexValue();
            rep[17]=ht16.getHexValue();
            rep[18]=ht17.getHexValue();
            rep[19]=ht18.getHexValue();
            rep[20]=ht19.getHexValue();
            rep[21]=ht20.getHexValue();
            rep[22]=ht21.getHexValue();
            rep[23]=ht22.getHexValue();
            rep[24]=ht23.getHexValue();
            rep[25]=ht24.getHexValue();
            rep[26]=ht25.getHexValue();
            rep[27]=ht26.getHexValue();
            rep[28]=ht27.getHexValue();
            rep[29]=ht28.getHexValue();
            rep[30]=ht29.getHexValue();
            rep[31]=ht30.getHexValue();
            rep[32]=ht31.getHexValue();
            rep[33]=ht32.getHexValue();
            rep[34]=ht33.getHexValue();
            rep[35]=ht34.getHexValue();
            rep[36]=ht35.getHexValue();
            rep[37]=ht36.getHexValue();
            rep[38]=ht37.getHexValue();
            rep[39]=ht38.getHexValue();
            rep[40]=ht39.getHexValue();
            rep[41]=ht40.getHexValue();
            rep[42]=ht41.getHexValue();
            rep[43]=ht42.getHexValue();
            rep[44]=ht43.getHexValue();
            rep[45]=ht44.getHexValue();
            rep[46]=ht45.getHexValue();
            rep[47]=ht46.getHexValue();
            rep[48]=ht47.getHexValue();
            rep[49]=ht48.getHexValue();
            rep[50]=ht49.getHexValue();
            rep[51]=ht50.getHexValue();
            rep[52]=ht51.getHexValue();
            rep[53]=ht52.getHexValue();
            rep[54]=ht53.getHexValue();
            rep[55]=ht54.getHexValue();
            rep[56]=ht55.getHexValue();
            rep[57]=ht56.getHexValue();
            rep[58]=ht57.getHexValue();
            rep[59]=ht58.getHexValue();
            rep[60]=ht59.getHexValue();
            rep[61]=ht60.getHexValue();
            rep[62]=ht61.getHexValue();
            rep[63]=ht62.getHexValue();
            return rep;
        }
        
    }
}
